Option Explicit

'** Constantes
' Tipo de perfil
Const NET_FW_PROFILE2_DOMAIN = 1
Const NET_FW_PROFILE2_PRIVATE = 2
Const NET_FW_PROFILE2_PUBLIC = 4

' Protocolo
Const NET_FW_IP_PROTOCOL_TCP = 6
Const NET_FW_IP_PROTOCOL_UDP = 17
Const NET_FW_IP_PROTOCOL_ICMPv4 = 1
Const NET_FW_IP_PROTOCOL_ICMPv6 = 58

' Dirección
Const NET_FW_RULE_DIR_IN = 1
Const NET_FW_RULE_DIR_OUT = 2

' Acción
Const NET_FW_ACTION_BLOCK = 0
Const NET_FW_ACTION_ALLOW = 1

' Variables Globales
dim fwPolicy2, Rules, wshShell, fso, fwHome, fwHomeInput, blnFwHome, blnExisteCarpeta
set fwPolicy2 = CreateObject("HNetCfg.FwPolicy2")
set Rules = fwPolicy2.Rules
set wshShell = CreateObject("WScript.Shell")
set fso = CreateObject("Scripting.FileSystemObject")

' Funciones y procedimientos
function QuitaBackSlash(cadena)
	if Right(cadena, 1) = "\" then
		cadena = Right(cadena, Len(cadena) - 1)
	end if
	QuitaBackSlash = cadena
end function

function RuleExists(name)
	Dim Rule
	RuleExists = false
	For Each Rule in Rules
		if LCase(Rule.Name) = LCase(name) then
			RuleExists = True
		end if
	Next
end function

function Contains(name, arrayStr())
	Dim cadena, contiene
	
	contiene = true
	for each cadena in arrayStr
		'wscript.echo(name + " " + cadena)
		If InStr(1, name, cadena, vbTextCompare) = 0 Then
			contiene = false
		End If
	next
	Contains = contiene
end function

sub DeleteFirewallRule(name)
	If RuleExists(name) Then
		Rules.Remove name
		'WScript.Echo("Eliminada regla '" + name + "'")
	Else
		'WScript.Echo("No se ha encontrado la regla '" + name + "'")
	End If
end sub

sub CreateFirewallRule(name, localports, remoteaddresses)
	Dim NewRule
	set NewRule = CreateObject("HNetCfg.FWRule")
	
	DeleteFirewallRule name
	
	NewRule.Name = name
	NewRule.Protocol = NET_FW_IP_PROTOCOL_TCP
	NewRule.LocalPorts = localports
	NewRule.RemoteAddresses = remoteaddresses
	NewRule.Enabled = true
	NewRule.Action = NET_FW_ACTION_ALLOW
	
	Rules.Add NewRule
	'WScript.Echo("Creada regla '" + name + "'")
end sub

sub CreateFirewallRuleByApp(name, application)
	Dim NewRule
	set NewRule = CreateObject("HNetCfg.FWRule")
	
	'DeleteFirewallRule name
	
	NewRule.Name = name
	NewRule.ApplicationName = application
	NewRule.Enabled = false
	NewRule.Action = NET_FW_ACTION_ALLOW
	
	Rules.Add NewRule
	'WScript.Echo("Creada regla '" + name + "' con app '" + application + "'")
end sub

sub DisableFirewallRule(cadena())
	dim Rule
	for each Rule in Rules
		if Contains(Rule.ApplicationName, cadena) Then
			Rule.Enabled = false
			'WScript.Echo("Deshabilitada regla '" + Rule.Name + "'")
		end if
	next
end sub

sub EnableFirewallRule(cadena())
	dim Rule
	for each Rule in Rules
		if Contains(Rule.ApplicationName, cadena) Then
			Rule.Enabled = true
			'WScript.Echo("Habilitada regla '" + Rule.Name + "'")
		end if
	next
end sub

sub CreateFWJavaRules(rutaJava(), cadena())
	dim Rule, name, apName, javaexec
	for each Rule in Rules
		if Contains(Rule.ApplicationName, cadena) Then
			name = Rule.Name
			if not blnExisteCarpeta then
				fwHomeInput = Rule.ApplicationName
			end if
			DeleteFirewallRule name
		end if
	next
	
	if name = "" Then
		name = "Java(TM) Platform SE binary"
	End if
	
	if fwHomeInput <> "" Then
		for each javaexec in rutaJava
			fwHomeInput = Replace(fwHomeInput, javaexec, "")
		next
		
		for each javaexec in rutaJava
			apName = fwHomeInput + javaexec
			CreateFirewallRuleByApp name, apName
		next
	End If
	
end sub


fwHome = wshShell.ExpandEnvironmentStrings("%FUNDEWEB_HOME%")

if fso.FolderExists(fwHome) then
	blnFwHome = true
	fwHome = QuitaBackSlash(fwHome)
	fwHome = fwHome + "\FundeWeb\2.0\Java\jdk1.7.0"
	WScript.Echo fwHome
	fwHomeInput = InputBox("Ruta a Java de FundeWeb (por defecto '" + fwHome + "'):")
	if fwHomeInput = "" then
		fwHomeInput = fwHome
	end if
else
	blnFwHome = false
	fwHomeInput = InputBox("Ruta a Java de FundeWeb:")
end if

blnExisteCarpeta = true
if not fso.FolderExists(fwHomeInput) then
	WScript.Echo("No existe la ruta " + fwHomeInput)
	if blnFwHome Then
		blnExisteCarpeta = true
		fwHomeInput = fwHome
	else
		blnExisteCarpeta = false
	end if
end if

fwHomeInput = QuitaBackSlash(fwHomeInput)

DeleteFirewallRule "Permitir WebLogic ATICA"
DeleteFirewallRule "Weblogic 7000-7010 TCP"
DeleteFirewallRule "Bloquear puertos WebLogic"
CreateFirewallRule "WebLogic TCP", "7001-7010,8001-8010", "155.54.211.144/28,155.54.212.0/24,155.54.215.0/24"
DisableFirewallRule array("fundeweb", "java")
CreateFWJavaRules array("\bin\java.exe", "\bin\javaw.exe"), array("fundeweb", "java")